﻿Option Strict On
Option Explicit On

Imports System.Numerics
Imports exc.jdbi.FiniteFieldArithmetics

' Copyright © exc-jdbi 2021
' © Finite Field  2012
' © Finite Field  2012 Is Free Software
' https://www.vb-paradise.de/index.php/User/23082-exc-jdbi/
' github.com/exc-jdbi



'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'!!!! Sofern es hier zu einem Fehler kommt, ist das  !!!!
'!!!! irreduzible Polynom event. doch nicht korrekt. !!!!
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


Public Module TestFiniteFields

  Public ReadOnly Rand As Random = New Random

  Public Sub Main()
    TestFiniteField()
    TestPrime2147483647()
    TestGF3_255()

    Console.WriteLine() : Console.WriteLine()
    Console.WriteLine("Finish")
    Console.ReadLine()

  End Sub

  Private Sub TestFiniteField()
    'Polynomial = x ^ 6 + x ^ 4 + 4 * x ^ 3 + x ^ 2 + 2 = 15625 + 625 + 500 + 25 + 2 = 16777
    Dim polynomial = 16777 ' FiniteField.FromPolynom(New Int64() {1, 0, 1, 4, 1, 0, 2}, 5)
    Dim gfx_1, gfx_2, gfx_3, gfx_4 As FiniteField

    Dim cnt = 1000
    Dim _max = 16777

    Dim sw = Stopwatch.StartNew
    For i = 0 To cnt
      gfx_1 = New FiniteField(5, 6, polynomial, Rand64(1, Int64.MaxValue))
      gfx_2 = New FiniteField(5, 6, polynomial, Rand64(1, Int64.MaxValue))


      'Addition
      gfx_3 = gfx_1 + gfx_2
      gfx_4 = gfx_3 - gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      'Subtraktion
      gfx_3 = gfx_1 - gfx_2
      gfx_4 = gfx_3 + gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      If gfx_2 = 0 Then Continue For


      'Multiplikation
      gfx_3 = gfx_1 * gfx_2
      gfx_4 = gfx_3 / gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      'Division
      gfx_3 = gfx_1 / gfx_2
      gfx_4 = gfx_3 * gfx_2
      Debug.Assert(gfx_1 = gfx_4)
    Next
    Console.WriteLine($"Test GF(5^6); cnt = {cnt}; t = {sw.ElapsedMilliseconds}")
  End Sub

  Private Sub TestPrime2147483647()
    'Da komplette BigInteger Version, kann der Generator
    'noch viel höher gesetzt werden. Es ist schlussendlich 
    'einfach eine Zeitfrage, wie lange dafür die Berechnung
    'dauert.

    Dim cnt = 20
    Dim sw = Stopwatch.StartNew
    Dim generator = 2147483647L 'Grösster Prime Int32
    'Dim generator = 3037000493L 'Max. Prime Int64

    Dim gfx_1, gfx_2, gfx_3, gfx_4 As FiniteField

    For i = 0 To cnt
      gfx_1 = New FiniteField(generator, Rand64(1, Int64.MaxValue))
      gfx_2 = New FiniteField(generator, Rand64(1, Int64.MaxValue))

      'Addition
      gfx_3 = gfx_1 + gfx_2
      gfx_4 = gfx_3 - gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      'Subtraktion
      gfx_3 = gfx_1 - gfx_2
      gfx_4 = gfx_3 + gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      If gfx_2 = 0 Then Continue For


      '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      '!!!! Sofern es hier zu einem Fehler kommt, ist das  !!!!
      '!!!! irreduzible Polynom event. doch nicht korrekt. !!!!
      '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


      'Multiplikation
      gfx_3 = gfx_1 * gfx_2
      gfx_4 = gfx_3 / gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      'Division
      gfx_3 = gfx_1 / gfx_2
      gfx_4 = gfx_3 * gfx_2
      Debug.Assert(gfx_1 = gfx_4)
    Next
    Console.WriteLine($"Test GF({generator}); cnt = {cnt}; t = {sw.ElapsedMilliseconds}")
  End Sub

  Private Sub TestGF3_255()
    Dim cnt = 2

    Dim sw = Stopwatch.StartNew
    Dim generator = 3L
    'Dim generator = 46337L '1073741789l ' 2147483647L'

    Dim exponent = 255

    'idp >> Mal so sein lassen, scheint eine gute Kombi zu sein.
    Dim idp = BigInteger.Pow(generator, exponent) + 5 * generator + 1
    Dim order = BigInteger.Pow(generator, exponent)

    Dim gfx_1, gfx_2, gfx_3, gfx_4 As FiniteField

    For i = 0 To cnt
      gfx_1 = New FiniteField(generator, exponent, idp, Rand64(1, Int64.MaxValue))
      gfx_2 = New FiniteField(generator, exponent, idp, Rand64(1, Int64.MaxValue))

      'Addition
      gfx_3 = gfx_1 + gfx_2
      gfx_4 = gfx_3 - gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      'Subtraktion
      gfx_3 = gfx_1 - gfx_2
      gfx_4 = gfx_3 + gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      If gfx_2 = 0 Then Continue For


      '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      '!!!! Sofern es hier zu einem Fehler kommt, ist das  !!!!
      '!!!! irreduzible Polynom event. doch nicht korrekt. !!!!
      '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


      'Multiplikation
      gfx_3 = gfx_1 * gfx_2
      gfx_4 = gfx_3 / gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      'Division
      gfx_3 = gfx_1 / gfx_2
      gfx_4 = gfx_3 * gfx_2
      Debug.Assert(gfx_1 = gfx_4)
    Next
    Console.WriteLine($"Test GF({generator}^{exponent}); cnt = {cnt}; t = {sw.ElapsedMilliseconds}")
  End Sub

  Private Function Rand64(min As Int64, max As Int64) As Int64
    Dim buf As Byte() = New Byte(7) {}
    Rand.NextBytes(buf)
    Dim longRand = BitConverter.ToInt64(buf, 0)
    Return Math.Abs(longRand Mod (max - min)) + min
  End Function

End Module
